;;************************************************************************
;;************************************************************************
;;
;;  CTBLOCK_1.ASM (from CTBLOCK.asm user module template)
;;  Rev A, 2001 October 9
;;
;;  Assembler source for 6-bit Generic Continuous-Time API
;;
;;  Copyright (c) Cypress MicroSystems 2001. All Rights Reserved.
;;
;;************************************************************************
;;************************************************************************
;;

export  CTBLOCK_1_Start
export _CTBLOCK_1_Start
export  CTBLOCK_1_SetPower
export _CTBLOCK_1_SetPower
export  CTBLOCK_1_Stop
export _CTBLOCK_1_Stop

;; -----------------------------------------------------------------
;;                         Register Definitions
;; -----------------------------------------------------------------
;; BIT FIELD            Mask 
;; -----------------    ----- 
;; CR0.RTapMux           F0
;; CR0.Gain				 08
;; CR0.RTopMux			 04
;; CR0.RBotMux			 03
;; 
;; CR1.AnalogBus		 80
;; CR1.CompBus			 40
;; CR1.NMux				 38
;; CR1.PMux				 03
;;
;; CR2.CPhase			 80
;; CR2.CLatch			 40
;; CR2.CompCap			 20
;; CR2.TestMux			 1C
;; CR2.Power			 03
;;

include "CTBLOCK_1.inc"
include "m8c.inc"

PwrMask:		         equ 03h

 CTBLOCK_1_Start:
_CTBLOCK_1_Start:
 CTBLOCK_1_SetPower:
_CTBLOCK_1_SetPower:
    ;; Applies power setting to the SCBlock
    ;; INPUTS: brought in by A
    ;; OUTUTS: None
    and    A, PwrMask
    push   X
    mov    X, SP
    push   A
    mov    A, reg[CTBLOCK_1_CR3]
    and    A, ~PwrMask
    or     A, [X]
    mov    reg[CTBLOCK_1_CR3], A
    pop    A
    pop    X
    ret

 CTBLOCK_1_Stop:
_CTBLOCK_1_Stop:
    ;; Cuts power to the user module.
    ;; INPUTS:  None
    ;; OUTPUTS: None
    ;; Machine cycles required: Setup (?) + Call(11 or 13) + 13
    and     reg[CTBLOCK_1_CR3], ~PwrMask
    ret
