;;;API for the Switched cap User Module
;;; Copyright (c) 2000 Cypress Microsystems, Inc. All rights reserved.
;;; Version "0.0-2001.03.19"
;;; UserModuleID "SCBLOCK"

export  SCBLOCK_2_Start
export _SCBLOCK_2_Start
export  SCBLOCK_2_SetPower
export _SCBLOCK_2_SetPower
export  SCBLOCK_2_Stop
export _SCBLOCK_2_Stop

;; -----------------------------------------------------------------
;;                         Register Definitions
;; -----------------------------------------------------------------
;; BIT FIELD            Mask 
;; -----------------    ----- 
;; CR0.FCap              80
;; CR0.ClockPhase        40
;; CR0.ASign             20
;; CR0.ACap              1F
;; 
;; CR1.AMux              C0   SCB
;; CR1.ACMux             C0   SCA
;; CR1.BCap              1F
;;
;; CR2.AnalogBus         80
;; CR2.CmpBus            40
;; CR2.AutoZero          20
;; CR2.CCap              1F
;;
;; CR3.RefSelect         C0
;; CR3.FSW1              20
;; CR3.FSW0              10
;; CR3.BSW               08   SCB
;; CR3.BMux              04   SCB
;; CR3.BMux              0C   SCA
;; CR3.Power             03
;;

include "SCBLOCK_2.inc"
include "m8c.inc"

 SCBLOCK_2_Start:
_SCBLOCK_2_Start:
 SCBLOCK_2_SetPower:
_SCBLOCK_2_SetPower:
   ;; Applies power setting to the SCBlock
   ;; INPUTS: brought in by A
   ;; OUTUTS: None
   and A,03h
   push X
   mov X,SP

   push A
   mov A,reg[SCBLOCK_2_SCBLOCKcr3]
   and A,~03h
   or  A,[X]
   mov reg[SCBLOCK_2_SCBLOCKcr3],A
   pop A
   pop X
   ret

 SCBLOCK_2_Stop:
_SCBLOCK_2_Stop:
   ;; Cuts power to the user module.
   ;; INPUTS:  None
   ;; OUTPUTS: None
   ;; Machine cycles required: Setup (?) + Call(11 or 13) + 13
   and reg[SCBLOCK_2_SCBLOCKcr3],~03h
   ret
