;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Macros for the Piano Project
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   ProcessVoice
;;
;;  Register used:
;;   iVoiceMS X
;;   iVoiceLS X
;;   iVoiceDeltaMS X
;;   iVoiceDeltaLS X    
;;   iVoiceTaperMS X
;;   iVoiceTaperLS X     
;;   cVoiceTaperDel X
;;   cVoiceStatus X
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
macro ProcessVoice
   cmp [(cVoiceStatus + @0)],255
   jnz else1m@0
   if1m@0:;(voice off)
      mov A,0
      push A                         ;push 0 taper
      push A                         ;push 0 voice
      jmp endif1m@0
   else1m@0:;(voice on)
     ;adjust Taper
      mov A,[(cVoiceTaperDel +@0)]
      add [(iVoiceTaperLS + @0)],A
      adc [(iVoiceTaperMS + @0)],0   ;iVoiceTaperMSByte
      jnc else2m@0
     ;if2m@0(taper finished)
         mov A,0
         push A                      ;push 0 taper
         push A                      ;push 0 voice
         cpl A
         mov [(cVoiceStatus +@0)],A  ;cVoiceStatus is off
         jmp  endif2m@0
      else2m@0:;(still taper) 
         mov X,[(iVoiceTaperMS + @0)];iVoiceTaperMSByte
         mov A,[cTaper]
         romx
         push A                      ;push taper
                                     ;adjust voice
         mov  A,[(iVoiceDeltaLS + @0)]                                             
         add  [(iVoiceLS + @0)],A
         mov  A,[(iVoiceDeltaMS + @0)]
         adc  [(iVoiceMS + @0)],A
         mov  X,[(iVoiceMS + @0)]
         mov  A,[cInstrument]     
        romx
        push A                        ;push voice
      endif2m@0:
   endif1m@0:
ENDM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   MACVoiceFromStack
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
macro MACVoiceFromStack
   pop A 
   mov reg[MUL_X],A
   pop A
   mov reg[MAC_Y],A
ENDM

